#!/usr/bin/lua

takt=require"takt"
takt.settime(1)-- 1s base poll time 
takt.settok(300) --100 ms fast poll

function Deploy(file) --find and open the device
 local file,_=io.open(file) 
 if file then    
  WFile=file
  WFile:setvbuf("no")
  Updatewheel= function() WFile:seek('set') return WFile:read() end
 end   
end
--one of these may be right
Deploy("/sys/bus/iio/devices/iio:device0/in_voltage2_input")
Deploy("/sys/bus/iio/devices/iio:device1/in_voltage2_input")
Deploy("/sys/bus/iio/devices/iio:device2/in_voltage2_input")
Deploy("/sys/bus/iio/devices/iio:device3/in_voltage2_input")
Deploy("/sys/bus/iio/devices/iio:device4/in_voltage2_input")
Lastcheck=tonumber(Updatewheel())

local tik=takt.tik
local tok=takt.tok
while true do
-- print(tmpcheck,Lastcheck,"slow" )
 tik()
 local tmpcheck=tonumber(Updatewheel())
 if math.abs(Lastcheck-tmpcheck)>3 then --A greater number prevents being triggered by flickering at the cost of precicion.
  for x=1,100 do --100 times 100ms
--   print(tmpcheck,Lastcheck,"fast" )
   tmpcheck=tonumber(Updatewheel())
   os.execute("pactl set-sink-volume 0 "..math.floor(100/1225*tmpcheck) .."% ") --OS calls are ugly of course.
   tok()
  end
  Lastcheck=tmpcheck
 end
end
